| Flutter Impeller |

Public Member Functions | List of all members
impeller::VerticesColorContents Class Referencefinal

`#include <vertices_contents.h>`

Inheritance diagram for impeller::VerticesColorContents:

## Public Member Functions
| VerticesColorContents (const VerticesContents &parent)
| ~VerticesColorContents () override
std::optional< Rect > | GetCoverage (const Entity &entity) const override
| Get the screen space bounding rectangle that this contents affects. More...
bool | Render (const ContentContext &renderer, const Entity &entity, RenderPass &pass) const override
void | SetAlpha (Scalar alpha)
Public Member Functions inherited from impeller::Contents
| Contents ()
virtual | ~Contents ()
virtual void | PopulateGlyphAtlas (const std::shared_ptr< LazyGlyphAtlas > &lazy_glyph_atlas, Scalar scale)
| Add any text data to the specified lazy atlas. The scale parameter must be used again later when drawing the text. More...
void | SetCoverageHint (std::optional< Rect > coverage_hint)
| Hint that specifies the coverage area of this Contents that will actually be used during rendering. This is for optimization purposes only and can not be relied on as a clip. May optionally affect the result of `GetCoverage()`. More...
const std::optional< Rect > & | GetCoverageHint () const
virtual bool | IsOpaque () const
| Whether this Contents only emits opaque source colors from the fragment stage. This value does not account for any entity properties (e.g. the blend mode), clips/visibility culling, or inherited opacity. More...
virtual StencilCoverage | GetStencilCoverage (const Entity &entity, const std::optional< Rect > &current_stencil_coverage) const
| Given the current screen space bounding rectangle of the stencil, return the expected stencil coverage after this draw call. This should only be implemented for contents that may write to the stencil buffer. More...
virtual std::optional< Snapshot > | RenderToSnapshot (const ContentContext &renderer, const Entity &entity, std::optional< Rect > coverage_limit=std::nullopt, const std::optional< SamplerDescriptor > &sampler_descriptor=std::nullopt, bool msaa_enabled=true, const std::string &label="Snapshot") const
| Render this contents to a snapshot, respecting the entity's transform, path, stencil depth, and blend mode. The result texture size is always the size of `GetCoverage(entity)`. More...
virtual bool | ShouldRender (const Entity &entity, const std::optional< Rect > &stencil_coverage) const
std::optional< Size > | GetColorSourceSize () const
| Return the color source's intrinsic size, if available. More...
void | SetColorSourceSize (Size size)
virtual bool | CanInheritOpacity (const Entity &entity) const
| Whether or not this contents can accept the opacity peephole optimization. More...
virtual void | SetInheritedOpacity (Scalar opacity)
| Inherit the provided opacity. More...
virtual std::optional< Color > | AsBackgroundColor (const Entity &entity, ISize target_size) const
| Returns a color if this Contents will flood the given `target_size` with a color. This output color is the "Source" color that will be used for the Entity's blend operation. More...
virtual const FilterContents * | AsFilter () const
| Cast to a filter. Returns `nullptr` if this Contents is not a filter. More...
virtual bool | ApplyColorFilter (const ColorFilterProc &color_filter_proc)
| If possible, applies a color filter to this contents inputs on the CPU. More...

## Additional Inherited Members
Public Types inherited from impeller::Contents
using | ColorFilterProc = std::function< Color(Color)>
using | RenderProc = std::function< bool(const ContentContext &renderer, const Entity &entity, RenderPass &pass)>
using | CoverageProc = std::function< std::optional< Rect >(const Entity &entity)>
Static Public Member Functions inherited from impeller::Contents
static std::shared_ptr< Contents > | MakeAnonymous (RenderProc render_proc, CoverageProc coverage_proc)

## Detailed Description

Definition at line 58 of file vertices_contents.h.

## Constructor & Destructor Documentation

## ◆ VerticesColorContents()

impeller::VerticesColorContents::VerticesColorContents | ( | const VerticesContents & | parent | ) |
| explicit

Definition at line 160 of file vertices_contents.cc.

161 : parent_(parent) {}

## ◆ ~VerticesColorContents()

impeller::VerticesColorContents::~VerticesColorContents | ( |  | ) |
| override

Definition at line 163 of file vertices_contents.cc.

163 {}

## Member Function Documentation

## ◆ GetCoverage()

std::optional< Rect > impeller::VerticesColorContents::GetCoverage | ( | const Entity & | entity | ) | const
| override virtual

Get the screen space bounding rectangle that this contents affects.

Implements impeller::Contents.

Definition at line 165 of file vertices_contents.cc.

166 {
167 return parent_.GetCoverage(entity);
168 }

References impeller::VerticesContents::GetCoverage().

## ◆ Render()

bool impeller::VerticesColorContents::Render | ( | const ContentContext & | renderer,
|  | const Entity & | entity,
|  | RenderPass & | pass
| ) |  | const
| override virtual

Implements impeller::Contents.

Definition at line 174 of file vertices_contents.cc.

176 {
177 using VS = GeometryColorPipeline::VertexShader;
178 using FS = GeometryColorPipeline::FragmentShader;
179
180 Command cmd;
181 DEBUG_COMMAND_INFO(cmd, "VerticesColors");
182 auto& host_buffer = pass.GetTransientsBuffer();
183 auto geometry = parent_.GetGeometry();
184
185 auto geometry_result =
186 geometry->GetPositionColorBuffer(renderer, entity, pass);
187 auto opts = OptionsFromPassAndEntity(pass, entity);
188 opts.primitive_type = geometry_result.type;
189 cmd.pipeline = renderer.GetGeometryColorPipeline(opts);
190 cmd.stencil_reference = entity.GetStencilDepth();
191 cmd.BindVertices(geometry_result.vertex_buffer);
192
193 VS::FrameInfo frame_info;
194 frame_info.mvp = geometry_result.transform;
195 VS::BindFrameInfo(cmd, host_buffer.EmplaceUniform(frame_info));
196
197 FS::FragInfo frag_info;
198 frag_info.alpha = alpha_;
199 FS::BindFragInfo(cmd, host_buffer.EmplaceUniform(frag_info));
200
201 return pass.AddCommand(std::move(cmd));
202 }

References impeller::RenderPass::AddCommand(), impeller::Command::BindVertices(), DEBUG_COMMAND_INFO, impeller::VerticesContents::GetGeometry(), impeller::ContentContext::GetGeometryColorPipeline(), impeller::Entity::GetStencilDepth(), impeller::RenderPass::GetTransientsBuffer(), impeller::OptionsFromPassAndEntity(), impeller::Command::pipeline, and impeller::Command::stencil_reference.

## ◆ SetAlpha()

void impeller::VerticesColorContents::SetAlpha | ( | Scalar | alpha | ) |

Definition at line 170 of file vertices_contents.cc.

170 {
171 alpha_ = alpha;
172 }

The documentation for this class was generated from the following files:

- impeller/entity/contents/vertices_contents.h
- impeller/entity/contents/vertices_contents.cc

DEBUG_COMMAND_INFO
#define DEBUG_COMMAND_INFO(obj, arg)
Definition: command.h:31
impeller::RenderPipelineT::FragmentShader
FragmentShader_ FragmentShader
Definition: pipeline.h:91
impeller::OptionsFromPassAndEntity
ContentContextOptions OptionsFromPassAndEntity(const RenderPass &pass, const Entity &entity)
Definition: contents.cc:30
impeller::VerticesContents::GetCoverage
std::optional< Rect > GetCoverage(const Entity &entity) const override
Get the screen space bounding rectangle that this contents affects.
Definition: vertices_contents.cc:25
impeller::RenderPipelineT::VertexShader
VertexShader_ VertexShader
Definition: pipeline.h:90
impeller::VerticesContents::GetGeometry
std::shared_ptr< VerticesGeometry > GetGeometry() const
Definition: vertices_contents.cc:37